#include <hmg.ch>

   
function _HMGAnywhereSearch( cControlName, cWindowName, lAnywhereSearch )
   local lFound := .f.
   local nEventMsg := EventMsg()
   local ch
   local nVKDown := HMG_GetLastVirtualKeyDown()
   local cText := ''
   local nLineNo := 0
   local nItemCount := 0
   default lAnywhereSearch := .f.
   
   if .not. iscontroldefined( _AnywhereLabel, &cWindowName )
      define label _anywherelabel
         parent &cWindowName
         row GetProperty( cWindowName, 'HEIGHT' ) - 80
         col 0
         width GetProperty( cWindowName, cControlName, 'WIDTH' ) 
         transparent .t.
//         backcolor { 0, 0, 255 }
         fontcolor { 255, 0, 0 }
         fontname 'Arial'
         fontsize 14
         fontbold .t.
         autosize .t.
      end label
   endif   
   _HMGAnywhereSearchUpdate( cWindowName )
   
   ch := HMG_GetLastCharacter()
   HMG_CleanLastCharacter( .t. )
   nItemCount := GetProperty( cWindowName, cControlName, 'ITEMCOUNT' )
   
   
   do case
   case nVKDown == VK_BACK   //   backspace
      HMG_CleanLastVirtualKeyDown()
      _cAnywhereSearchStr := HB_ULEFT( _cAnywhereSearchStr, max( 0, ( HMG_Len( _cAnywhereSearchStr ) - 1 ) ) )
      _HMGAnywhereSearchUpdate( cWindowName )
   case nVKDown == VK_UP .or. nVKDown ==  VK_DOWN 
      HMG_CleanLastVirtualKeyDown()
      if hmg_len( _cAnywhereSearchStr ) == 0
         _HMGAnywhereSearchUpdate( cWindowName )
         return nil
      else
         nLineNo := _HMGAnywhereSearchGetRow( cWindowName, cControlName )
         if nVKDown == VK_UP
            lFound := .f.
            for i := nLineNo - 1 to 1 step - 1
               cText := _HMGAnywhereSearchGetText( cWindowName, cControlName, i )
               // first check in the starting chars... or anywhere searching if enabled
               if hmg_upper( _cAnywhereSearchStr ) == hb_uleft( hmg_upper( cText ), hmg_len( _cAnywhereSearchStr ) ) .or. if( lAnyWhereSearch, HB_UAT( hmg_upper( _cAnywhereSearchStr ), hmg_upper( cText )  ) > 0, .f. )
                  lFound := .t.
                  _HMGAnywhereSearchSetRow( cWindowName, cControlName, i )
                  exit
               endif  
            next i   
            if .not. lFound
               playbeep()
            endif                 
         else // down key search for next   
            lFound := .f.
            for i := nLineNo + 1 to nItemCount
               // first check in the starting chars...or anywhere searching if enabled
               cText := _HMGAnywhereSearchGetText( cWindowName, cControlName, i )
               if  hmg_upper( _cAnywhereSearchStr ) == hb_uleft( hmg_upper( cText ), hmg_len( _cAnywhereSearchStr ) ) .or. if( lAnyWhereSearch, HB_UAT( hmg_upper( _cAnywhereSearchStr ), hmg_upper( cText )  ) > 0, .f. )
                  lFound := .t.
                  _HMGAnywhereSearchSetRow( cWindowName, cControlName, i )
                  exit
               endif  
            next i   
            if .not. lFound
               playbeep()
            endif                 
         endif
         return 1 
      endif   
   case nVKDown == VK_ESCAPE
      HMG_CleanLastVirtualKeyDown()
      _cAnywhereSearchStr := ''
      _HMGAnywhereSearchUpdate( cWindowName )
      return 1
   case nVKDown ==  VK_RIGHT .or. nVKDown ==  VK_LEFT .or. nVKDown ==  VK_HOME .or. nVKDown ==  VK_END .or. nVKDown == VK_RETURN
      HMG_CleanLastVirtualKeyDown()
      _cAnywhereSearchStr := ''
      _HMGAnywhereSearchUpdate( cWindowName )
      return nil
   case EventIsMouseMessage () 
      HMG_CleanLastVirtualKeyDown()
//      _cAnywhereSearchStr := ''
      _HMGAnywhereSearchUpdate( cWindowName )
      return nil
   otherwise
      IF nEventMsg <> WM_CHAR
         Return Nil   // enable processing the current message
      ENDIF
      _cAnywhereSearchStr := _cAnywhereSearchStr + ch
      _HMGAnywhereSearchUpdate( cWindowName )
   endcase
   lFound := .f.
   for i := 1 to nItemCount
      // first check in the starting chars... or anywhere searching if enabled
      cText := _HMGAnywhereSearchGetText( cWindowName, cControlName, i )
      if  hmg_upper( _cAnywhereSearchStr ) == hb_uleft( hmg_upper( cText ), hmg_len( _cAnywhereSearchStr ) ) .or. if( lAnyWhereSearch, HB_UAT( hmg_upper( _cAnywhereSearchStr ), hmg_upper( cText )  ) > 0, .f. )
         lFound := .t.
         _HMGAnywhereSearchSetRow( cWindowName, cControlName, i )
         exit
      endif  
   next i   
   if .not. lFound
      playbeep()
      _cAnywhereSearchStr := HB_ULEFT( _cAnywhereSearchStr, max( 0, ( HMG_Len( _cAnywhereSearchStr ) - 1 ) ) )
      _HMGAnywhereSearchUpdate( cWindowName )
   endif      
   return 1


function _HMGAnywhereSearchUpdate( cWindowName )
   if iscontroldefined( _anywherelabel, &cWindowName )
      if hmg_len( alltrim( _cAnywhereSearchStr ) ) > 0
         setproperty( cWindowName, '_anywherelabel', 'VISIBLE', .t. )
      else   
         setproperty( cWindowName, '_anywherelabel', 'VISIBLE', .f. )
      endif   
      setproperty( cWindowName, '_anywherelabel', 'VALUE', _cAnywhereSearchStr )
   endif
return nil

function _HMGAnywhereSearchClear( )
   local cWindowName := thiswindow.name
   _cAnywhereSearchStr := ''
   if iscontroldefined( _anywherelabel, &cWindowName )
      DoMethod( cWindowName, '_anywherelabel', 'RELEASE' )
   endif
return nil

function _HMGAnywhereSearchGetRow( cWindowName, cControlName )
   local cType := ''
   local nLineNo := 0
   local aValue := {}
   local aLineData := {}
   local i := 0
   cType := GetControlType( cControlName, cWindowName )
   do case
   case cType == 'GRID'
      if getproperty( cWindowName, cControlName, 'CELLNAVIGATION' )
         aValue := getproperty( cWindowName, cControlName, 'VALUE' )
         if hmg_len( aValue ) > 0
            nLineNo := aValue[ 1 ]
         endif   
      else
         nLineNo := getproperty( cWindowName, cControlName, 'VALUE' )
      endif   
   case cType == 'MULTIGRID'
      if getproperty( cWindowName, cControlName, 'CELLNAVIGATION' )
         aValue := getproperty( cWindowName, cControlName, 'VALUE' )
         if hmg_len( aValue ) > 0
            if hmg_len( aValue[ 1 ] ) > 0
               nLineNo := aValue[ 1 ][ 1 ]
            endif   
         endif   
      else
         aValue := getproperty( cWindowName, cControlName, 'VALUE' )
         if hmg_len( aValue ) > 0
            nLineNo := aValue[ 1 ]
         endif   
      endif
   case cType == 'TREE' 
      // careful! Trees can be with ITEMIDs too! Find ItemIDs position
      aValue := GetProperty( cWindowName, cControlName, 'ALLVALUE' )
      for i := 1 to hmg_len( aValue )
         if aValue[ i ] == GetProperty( cWindowName, cControlName, 'VALUE' )
            // yes! this is the current position
            nLineNo := i
            exit
         endif
      next i
   case cType == 'COMBO' .or. cType == 'LIST'
      nLineNo := getproperty( cWindowName, cControlName, 'VALUE' )
   case cType == 'MULTILIST'
      aValue := getproperty( cWindowName, cControlName, 'VALUE' )
      if hmg_len( aValue ) > 0
         nLineNo := aValue[ 1 ]
      endif   
   endcase   
return nLineNo

function _HMGAnywhereSearchGetText( cWindowName, cControlName, nRow, nCol )
   local cText := ''
   local cType := ''
   local aValue := {}
   local aLineData := {}
   default nCol := 1
   cType := GetControlType( cControlName, cWindowName )
   do case
   case cType == 'GRID' .or. cType == 'MULTIGRID'
      cText := getproperty( cWindowName, cControlName, 'CELL', nRow, nCol )
   case cType == 'TREE' 
      // careful! Trees can be with ITEMIDs too! Find ItemID and get the text
      aValue := GetProperty( cWindowName, cControlName, 'ALLVALUE' )
      cText := GetProperty( cWindowName, cControlName, 'ITEM', aValue[ nRow ] )
   case cType == 'COMBO' .or. cType == 'LIST' .or. cType == 'MULTILIST'
      cText := getproperty( cWindowName, cControlName, 'ITEM', nRow )
   endcase   
return cText

function _HMGAnywhereSearchSetRow( cWindowName, cControlName, nRow, nCol )
   local cType := ''
   local nLineNo := 0
   local aValue := {}
   local aLineData := {}
   default nCol := 1
   cType := GetControlType( cControlName, cWindowName )
   do case
   case cType == 'GRID'
      if getproperty( cWindowName, cControlName, 'CELLNAVIGATION' )
         Setproperty( cWindowName, cControlName, 'VALUE', { nRow, 1 } )
      else
         setproperty( cWindowName, cControlName, 'VALUE', nRow )
      endif   
   case cType == 'MULTIGRID'
      if getproperty( cWindowName, cControlName, 'CELLNAVIGATION' )
         setproperty( cWindowName, cControlName, 'VALUE', { { nRow, 1 } } )
      else
         setproperty( cWindowName, cControlName, 'VALUE', { nRow } )
      endif   
   case cType == 'TREE' 
      // careful! Trees can be with ITEMIDs too! Find ItemID and get the text
      aValue := GetProperty( cWindowName, cControlName, 'ALLVALUE' )
      SetProperty( cWindowName, cControlName, 'VALUE', aValue[ nRow ] )
//      msginfo( str( aValue[ nRow ] ) + ', ' + str( nRow ) )
   case cType == 'COMBO' .or. cType == 'LIST'
      Setproperty( cWindowName, cControlName, 'VALUE', nRow )
   case cType == 'MULTILIST'
      setproperty( cWindowName, cControlName, 'VALUE', { nRow } )
   endcase   
return nil
